﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Networking;

public class FinalScreen : MonoBehaviour
{
  public UILabel[] Top5;
  public UILabel PlayerScore;

  // Start is called before the first frame update
  void Start()
  {
    StartCoroutine(Upload());
  }

  // Update is called once per frame
  void Update()
  {

  }
  IEnumerator RetrieveScore()
  {
    WWWForm form = new WWWForm();
    string uniqueID = SettingsSingleton.Instance.mGuid.ToString();
    form.AddField("uniqueid", uniqueID);
    UnityWebRequest www = UnityWebRequest.Post("http://vrmapper.fabiocorrirossi.com/ggj2021/retrieve_score.php", form);
    yield return www.SendWebRequest();

    if (www.isNetworkError || www.isHttpError)
    {
      Debug.Log(www.error);
    }
    else
    {
      Debug.Log(www.downloadHandler.text);
      PlayerScore.text = www.downloadHandler.text;
    }
  }


  IEnumerator RetrieveLeaderboard()
  {
    WWWForm form = new WWWForm();
    UnityWebRequest www = UnityWebRequest.Post("http://vrmapper.fabiocorrirossi.com/ggj2021/retrieve_leaderboard.php", form);
    yield return www.SendWebRequest();

    if (www.isNetworkError || www.isHttpError)
    {
      Debug.Log(www.error);
    }
    else
    {
      Debug.Log(www.downloadHandler.text);

      string[] lines = www.downloadHandler.text.Split(new[] { "\r\n", "\r", "\n" }, StringSplitOptions.None);
      for (int i = 0; i < Top5.Length; i++)
      {
        Top5[i].text = "";
      }
      for(int i=0;i<lines.Length;i++)
      {
        if(lines[i]!="")
          Top5[i].text = (i+1).ToString() + ":" +lines[i];
        if (i == Top5.Length - 1)
          break;
      }
    }
  }

  IEnumerator Upload()
  {
    if(SettingsSingleton.Instance.TotalTime>0f)
    {
      WWWForm form = new WWWForm();
      string uniqueID = SettingsSingleton.Instance.mGuid.ToString();
      form.AddField("uniqueid", uniqueID);
      form.AddField("name", SettingsSingleton.Instance.PlayerName);
      form.AddField("time", (int)(SettingsSingleton.Instance.TotalTime * 1000));

      UnityWebRequest www = UnityWebRequest.Post("http://vrmapper.fabiocorrirossi.com/ggj2021/upload_score", form);
      yield return www.SendWebRequest();

      if (www.isNetworkError || www.isHttpError)
      {
        Debug.Log(www.error);
      }
      else
      {
        Debug.Log("Form upload complete!");

        StartCoroutine(RetrieveScore());
        StartCoroutine(RetrieveLeaderboard());
      }
    }
  }
}
