﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Freezer : MonoBehaviour
{
  public GameObject mFlash;
  public MoveFlashlight mMoveFlashlight;
  public SpriteMask mSpriteMask;
  public StillImage mStillImage;
  public float mCooldwon = 3f;

  private float mTime = 0f;
  private bool mClicked = false;
  private int mClickedJuggle = 5;
  public void Start()
  {
  }
  private void Update()
  {
    mClickedJuggle--;
    if(mClickedJuggle<=0)
    {
      mClickedJuggle = 0;
      mClicked = false;
    }
    if (mTime>0f)
    {
      mTime -= Time.deltaTime;
      if (mTime < 0f)
      {
        mTime = 0f;
        mSpriteMask.enabled = true;
        mMoveFlashlight.enabled = true;
      }
    }
    if (Input.GetButtonDown("Fire1") && mTime == 0f)
    {
      mClicked = true;
      mClickedJuggle = 15;
      mTime = mCooldwon;
      mStillImage.transform.position = transform.position;
      mStillImage.ShowStillFlash(mCooldwon);
      mSpriteMask.enabled = false;
      mFlash.SetActive(true);
      mMoveFlashlight.enabled = false;
      Invoke("FlashOff", 0.1f);
    }
  }
  private void FlashOff()
  {
    mFlash.SetActive(false);
  }
  private void OnTriggerStay2D(Collider2D collision)
  {
    if (collision.gameObject.tag=="Freezable" || collision.gameObject.tag =="Guy")
    {
      if (mClicked)
      {
        FreezableObject[] freezable = collision.gameObject.GetComponents<FreezableObject>();
        foreach (var item in freezable)
        {
          Debug.Log("Freezing:" + item.name);
          item.Freeze(mCooldwon);
        }
      }
    }
  }
}
