﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Laser : FreezableObject
{
  public Sprite[] mLasers;
  public float mCooldown;
  public float mTurnedOffTime;

  private float mTime = 0f;
  private SpriteRenderer mSpriteRenderer;
  private int mSpriteIndex = 0;

  private enum States
  {
    LASER_ON,
    LASER_OFF
  }
  private States mState = States.LASER_ON;

  private void Start()
  {
    mSpriteRenderer = GetComponent<SpriteRenderer>();
    InvokeRepeating("UpdateLaser", 0f, 0.05f);
  }
  private void UpdateLaser()
  {
    mSpriteRenderer.sprite = mLasers[mSpriteIndex];
    mSpriteIndex++;
    if (mSpriteIndex>=mLasers.Length)
    {
      mSpriteIndex = 0;
    }
  }
  private void Update()
  {
    mTime += Time.deltaTime;
    switch (mState)
    {
      case States.LASER_ON:
        if(mTime>mCooldown)
        {
          mState = States.LASER_OFF;
          mTime = 0f;
          GetComponent<SpriteRenderer>().enabled = false;
          GetComponent<Collider2D>().enabled = false;
        }
        break;
      case States.LASER_OFF:
        if (mTime > mTurnedOffTime)
        {
          mState = States.LASER_ON;
          mTime = 0f;
          GetComponent<SpriteRenderer>().enabled = true;
          GetComponent<Collider2D>().enabled = true;
        }
        break;
      default:
        break;
    }
  }
}