﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class LightObject : FreezableObject
{
  public TweenAlpha mTweenAlpha;

  private bool mIsFreezed = false;

  public override void Freeze(float freezeTime)
  {
    Debug.Log("Light Freezed");
    mIsFreezed = true;
    mTweenAlpha.enabled = false;
    CancelInvoke("StartFading");
    Invoke("Unfreeze", freezeTime);
  }
  private void Unfreeze()
  {
    mIsFreezed = false;
    StartFading();
  }
  private void OnCollisionEnter2D(Collision2D collision)
  {
    if (collision.gameObject.tag == "Guy")
    {
      Movement guyMovement = collision.gameObject.GetComponent<Movement>();
      if (guyMovement)
      {
        StartFading();
      }
    }
  }
  private void StartFading()
  {
    Debug.Log("Start Fading"+ mIsFreezed);
    if (mIsFreezed)
    {
      return;
    }
    mTweenAlpha.enabled = true;
    mTweenAlpha.PlayForward();
  }
  private void OnAlphaFinished()
  {
    GetComponent<BoxCollider2D>().enabled = false;
  }
  // Start is called before the first frame update
  void Start()
  {
    CancelInvoke();
    mTweenAlpha.enabled = false;
    mTweenAlpha.AddOnFinished(OnAlphaFinished);
  }

  // Update is called once per frame
  void Update()
  {

  }
}