﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RepeatAction : FreezableObject
{
  public UITweener mTween;
  public float mRedoTime;
  public bool mOneTime = false;

  public override void Freeze(float freezeTime)
  {
    CancelInvoke("ReDo");
    mTween.enabled = false;
    Invoke("ReDo", freezeTime);
    KillerObject killer= GetComponent<KillerObject>();
    if(killer)
    {
      killer.mCanKill = false;
    }
  }

  void Start()
  {
    mTween.enabled = false;
    if(!mOneTime)
      mTween.AddOnFinished(TweenCallback);
    TweenCallback();
  }
  void TweenCallback()
  {
    CancelInvoke("ReDo");
    mTween.ResetToBeginning();
    Invoke("ReDo", mRedoTime);
  }
  // Update is called once per frame
  void ReDo()
  {
    KillerObject killer = GetComponent<KillerObject>();
    if (killer)
    {
      killer.mCanKill = true;
    }
    mTween.enabled = true;
    mTween.PlayForward();
  }
}
