﻿using UnityEngine;
using System.Collections;

public class SettingsSingleton : Singleton<SettingsSingleton>
{
	public int test = 15;
  public System.Guid mGuid;
  public string PlayerName="PlayerName";

  public UILabel MusicLabel;

  public float TotalTime = 0f;

  private bool mGuidGenerated = false;

  private bool mMusicOn = true;
  
  public void ToggleMusic()
  {
    mMusicOn = !mMusicOn;
    MusicLabel.text = mMusicOn ? "Music: On" : "Music: Off";
    if (mMusicOn)
      GetComponent<AudioSource>().Play();
    else
      GetComponent<AudioSource>().Stop();
  }
  public void GeneratePlayerGuid(bool force=false)
  {
    if(!mGuidGenerated || force)
    {
      mGuidGenerated = true;
      mGuid = System.Guid.NewGuid();
      Debug.Log("GUID:" + mGuid.ToString());
    }
  }
  public void Start()
	{
    GeneratePlayerGuid();
  }
}